/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.wahl.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="WAHLTERMIN.UK",
     query="SELECT o FROM Wahltermin o WHERE "

                         + "o"
                +".nummer"
              +" = ?1"

             +" AND "         + "o"
                +".wahldatum"
              +" = ?2"

             +" AND "         + "o"
                +".mandant"
                +".nummer"
              +" = ?3"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="WAHLTERMIN.All",
     query="SELECT o FROM Wahltermin o WHERE o.mandant=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLTERMIN.AllNummerWithNummern",
     query="SELECT o.nummer FROM Wahltermin o WHERE o.mandant=?1 AND o.nummer IN ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLTERMIN.AllSystemweit",
     query="SELECT o FROM Wahltermin o",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLTERMIN.AllWithNummern",
     query="SELECT o FROM Wahltermin o WHERE o.mandant=?1 AND o.nummer IN ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLTERMIN.IdPrefetchWahlen",
     query="SELECT o FROM Wahltermin o LEFT JOIN FETCH o.wahlsByWahltermin wahl LEFT JOIN FETCH wahl.wahlart wahlart WHERE o.id = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLTERMIN.Name",
     query="SELECT o FROM Wahltermin o WHERE o.mandant=?1 AND o.name = ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLTERMIN.Status",
     query="SELECT o FROM Wahltermin o WHERE o.mandant=?1 AND o.status = ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLTERMIN.WahldatumAndNummer",
     query="SELECT o FROM Wahltermin o WHERE o.mandant=?1 AND o.wahldatum = ?2 AND o.nummer = ?3",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "WAHLTERMIN")
// @javax.persistence.IdClass(WahlterminPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Wahltermin
extends AbstractWahltermin
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor (protected, da mit CustomData aufgerufen werden muss)
   */
  protected Wahltermin() {
    super();
  }
    public Wahltermin(de.ivu.elect.jee.entity.customdata.CustomData customData){
                      if (customData != null && de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE != customData) {
          customData.setTechnicalEntity(this);
          customDataStorage = new de.ivu.elect.business.customdata.entity.CustomDataStorage(customData);
        }
            }



    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Wahltermin(Wahltermin original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "wahltermin_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Wahltermin")
    @javax.persistence.TableGenerator(name = "Wahltermin", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Wahltermin", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient WahlterminPK pkCache;

  @Override
  public WahlterminPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new WahlterminPK(getId());
    }

    return pkCache;
  }

  public static <E extends Wahltermin> java.util.Map<WahlterminPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<WahlterminPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Wahltermin> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedBuergerZugelassen = false;
          hasChangedDokumentvorlagen = false;
          hasChangedFarbe = false;
          hasChangedName = false;
          hasChangedNummer = false;
          hasChangedStatus = false;
          hasChangedStichwahlMoeglich = false;
          hasChangedStichwahlWahldatum = false;
          hasChangedWahldatum = false;
  
      hasChangedCustomDataStorage = false;
        hasChangedEinsehenRolle = false;
        hasChangedMandant = false;
        hasChangedStichwahlWahlterminUrspruenglich = false;
  

                                                                                                          hasChangedWahlsByWahltermin = false;
              
    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "BUERGER_ZUGELASSEN", nullable = WahlterminConstants.BUERGER_ZUGELASSEN_NULLABLE)
    
  protected de.ivu.elect.business.personenpruefung.control.wahlrecht.WahlrechtStaatsangehoerigkeit buergerZugelassen =  de.ivu.elect.business.personenpruefung.control.wahlrecht.WahlrechtStaatsangehoerigkeit.DEUTSCH;

  @javax.persistence.Transient
  protected boolean hasChangedBuergerZugelassen = false;

  public boolean hasChangedBuergerZugelassen(){
    return hasChangedBuergerZugelassen;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBuergerZugelassen = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.personenpruefung.control.wahlrecht.WahlrechtStaatsangehoerigkeit wertNachLadenBuergerZugelassen;
  
  /**
   * 
   *
   * getter for WAHLTERMIN.BUERGER_ZUGELASSEN
   */
    @Override   public  de.ivu.elect.business.personenpruefung.control.wahlrecht.WahlrechtStaatsangehoerigkeit getBuergerZugelassen() {
        return buergerZugelassen;
      }

  /**
   * 
   *
   * setter for WAHLTERMIN.BUERGER_ZUGELASSEN
   *
   * @param buergerZugelassen
   */
  @Override   public void setBuergerZugelassen( de.ivu.elect.business.personenpruefung.control.wahlrecht.WahlrechtStaatsangehoerigkeit buergerZugelassen) {

       resetTkCache();
                  de.ivu.elect.business.personenpruefung.control.wahlrecht.WahlrechtStaatsangehoerigkeit buergerZugelassenInternal = buergerZugelassen;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.buergerZugelassen
      , buergerZugelassenInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBuergerZugelassen |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("buergerZugelassen");
      }


             if (!isSeitLadenVeraendertBuergerZugelassen) {
          isSeitLadenVeraendertBuergerZugelassen = thisAttributChanged;
         if (isSeitLadenVeraendertBuergerZugelassen){
           wertNachLadenBuergerZugelassen=this.buergerZugelassen;
         }
       }
      

       this.buergerZugelassen = buergerZugelassenInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "DOKUMENTVORLAGEN", nullable = WahlterminConstants.DOKUMENTVORLAGEN_NULLABLE)
    
  protected de.ivu.elect.business.wahl.entity.WahlartDokumentvorlagen dokumentvorlagen =  de.ivu.elect.business.wahl.entity.WahlartDokumentvorlagen.KEINE;

  @javax.persistence.Transient
  protected boolean hasChangedDokumentvorlagen = false;

  public boolean hasChangedDokumentvorlagen(){
    return hasChangedDokumentvorlagen;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertDokumentvorlagen = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.wahl.entity.WahlartDokumentvorlagen wertNachLadenDokumentvorlagen;
  
  /**
   * 
   *
   * getter for WAHLTERMIN.DOKUMENTVORLAGEN
   */
    @Override   public  de.ivu.elect.business.wahl.entity.WahlartDokumentvorlagen getDokumentvorlagen() {
        return dokumentvorlagen;
      }

  /**
   * 
   *
   * setter for WAHLTERMIN.DOKUMENTVORLAGEN
   *
   * @param dokumentvorlagen
   */
  @Override   public void setDokumentvorlagen( de.ivu.elect.business.wahl.entity.WahlartDokumentvorlagen dokumentvorlagen) {

       resetTkCache();
                  de.ivu.elect.business.wahl.entity.WahlartDokumentvorlagen dokumentvorlagenInternal = dokumentvorlagen;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.dokumentvorlagen
      , dokumentvorlagenInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedDokumentvorlagen |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("dokumentvorlagen");
      }


             if (!isSeitLadenVeraendertDokumentvorlagen) {
          isSeitLadenVeraendertDokumentvorlagen = thisAttributChanged;
         if (isSeitLadenVeraendertDokumentvorlagen){
           wertNachLadenDokumentvorlagen=this.dokumentvorlagen;
         }
       }
      

       this.dokumentvorlagen = dokumentvorlagenInternal;

         }

        
  @javax.persistence.Column(name = "FARBE", nullable = WahlterminConstants.FARBE_NULLABLE, length=WahlterminConstants.FARBE_MAX_LENGTH)
        
  protected java.lang.String farbe =  null;

  @javax.persistence.Transient
  protected boolean hasChangedFarbe = false;

  public boolean hasChangedFarbe(){
    return hasChangedFarbe;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertFarbe = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenFarbe;
  
  /**
   * 
   *
   * getter for WAHLTERMIN.FARBE
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getFarbe() {
        return farbe;
      }

  /**
   * 
   *
   * setter for WAHLTERMIN.FARBE
   *
   * @param farbe
   */
  @Override   public void setFarbe(@javax.annotation.Nullable  java.lang.String farbe) {

       resetTkCache();
                  
                          java.lang.String farbeInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(farbe, WahlterminConstants.FARBE_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.farbe
      , farbeInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedFarbe |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("farbe");
      }


             if (!isSeitLadenVeraendertFarbe) {
          isSeitLadenVeraendertFarbe = thisAttributChanged;
         if (isSeitLadenVeraendertFarbe){
           wertNachLadenFarbe=this.farbe;
         }
       }
      

       this.farbe = farbeInternal;

         }

        
  @javax.persistence.Column(name = "NAME", nullable = WahlterminConstants.NAME_NULLABLE, length=WahlterminConstants.NAME_MAX_LENGTH)
        
  protected java.lang.String name =  null;

  @javax.persistence.Transient
  protected boolean hasChangedName = false;

  public boolean hasChangedName(){
    return hasChangedName;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertName = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenName;
  
  /**
   * 
   *
   * getter for WAHLTERMIN.NAME
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getName() {
        return name;
      }

  /**
   * 
   *
   * setter for WAHLTERMIN.NAME
   *
   * @param name
   */
  @Override   public void setName(@javax.annotation.Nullable  java.lang.String name) {

       resetTkCache();
                  
                          java.lang.String nameInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(name, WahlterminConstants.NAME_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.name
      , nameInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedName |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("name");
      }


             if (!isSeitLadenVeraendertName) {
          isSeitLadenVeraendertName = thisAttributChanged;
         if (isSeitLadenVeraendertName){
           wertNachLadenName=this.name;
         }
       }
      

       this.name = nameInternal;

         }

        
      @javax.persistence.Column(name = "NUMMER", nullable = WahlterminConstants.NUMMER_NULLABLE, length=WahlterminConstants.NUMMER_MAX_LENGTH)
        
  protected java.lang.String nummer =  "0";

  @javax.persistence.Transient
  protected boolean hasChangedNummer = false;

  public boolean hasChangedNummer(){
    return hasChangedNummer;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertNummer = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenNummer;
  
  /**
   * 
   *
   * getter for WAHLTERMIN.NUMMER
   */
    @Override   public  java.lang.String getNummer() {
        return nummer;
      }

  /**
   * 
   *
   * setter for WAHLTERMIN.NUMMER
   *
   * @param nummer
   */
  @Override   public void setNummer( java.lang.String nummer) {

       resetTkCache();
                  
                          java.lang.String nummerInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(nummer, WahlterminConstants.NUMMER_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.nummer
      , nummerInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedNummer |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("nummer");
      }


             if (!isSeitLadenVeraendertNummer) {
          isSeitLadenVeraendertNummer = thisAttributChanged;
         if (isSeitLadenVeraendertNummer){
           wertNachLadenNummer=this.nummer;
         }
       }
      

       this.nummer = nummerInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "STATUS", nullable = WahlterminConstants.STATUS_NULLABLE)
    
  protected de.ivu.elect.business.wahl.entity.WahlterminStatus status =  de.ivu.elect.business.wahl.entity.WahlterminStatus.INITIAL;

  @javax.persistence.Transient
  protected boolean hasChangedStatus = false;

  public boolean hasChangedStatus(){
    return hasChangedStatus;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertStatus = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.wahl.entity.WahlterminStatus wertNachLadenStatus;
  
  /**
   * 
   *
   * getter for WAHLTERMIN.STATUS
   */
    @Override   public  de.ivu.elect.business.wahl.entity.WahlterminStatus getStatus() {
        return status;
      }

  /**
   * 
   *
   * setter for WAHLTERMIN.STATUS
   *
   * @param status
   */
  @Override   public void setStatus( de.ivu.elect.business.wahl.entity.WahlterminStatus status) {

       resetTkCache();
                  de.ivu.elect.business.wahl.entity.WahlterminStatus statusInternal = status;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.status
      , statusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("status");
      }


             if (!isSeitLadenVeraendertStatus) {
          isSeitLadenVeraendertStatus = thisAttributChanged;
         if (isSeitLadenVeraendertStatus){
           wertNachLadenStatus=this.status;
         }
       }
      

       this.status = statusInternal;

         }

        
      @javax.persistence.Column(name = "STICHWAHL_MOEGLICH", nullable = WahlterminConstants.STICHWAHL_MOEGLICH_NULLABLE)
    
  protected java.lang.Boolean stichwahlMoeglich =  false;

  @javax.persistence.Transient
  protected boolean hasChangedStichwahlMoeglich = false;

  public boolean hasChangedStichwahlMoeglich(){
    return hasChangedStichwahlMoeglich;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertStichwahlMoeglich = false;
     @javax.persistence.Transient
     private transient java.lang.Boolean wertNachLadenStichwahlMoeglich;
  
  /**
   * 
   *
   * getter for WAHLTERMIN.STICHWAHL_MOEGLICH
   */
    @Override   public  java.lang.Boolean getStichwahlMoeglich() {
        return stichwahlMoeglich;
      }

  /**
   * 
   *
   * setter for WAHLTERMIN.STICHWAHL_MOEGLICH
   *
   * @param stichwahlMoeglich
   */
  @Override   public void setStichwahlMoeglich( java.lang.Boolean stichwahlMoeglich) {

       resetTkCache();
                  java.lang.Boolean stichwahlMoeglichInternal = stichwahlMoeglich;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.stichwahlMoeglich
      , stichwahlMoeglichInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStichwahlMoeglich |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("stichwahlMoeglich");
      }


             if (!isSeitLadenVeraendertStichwahlMoeglich) {
          isSeitLadenVeraendertStichwahlMoeglich = thisAttributChanged;
         if (isSeitLadenVeraendertStichwahlMoeglich){
           wertNachLadenStichwahlMoeglich=this.stichwahlMoeglich;
         }
       }
      

       this.stichwahlMoeglich = stichwahlMoeglichInternal;

         }

        
  @javax.persistence.Temporal(javax.persistence.TemporalType.DATE)
  @javax.persistence.Column(name = "STICHWAHL_TERMIN", nullable = WahlterminConstants.STICHWAHL_TERMIN_NULLABLE, precision=WahlterminConstants.STICHWAHL_TERMIN_PRECISION)
    
  protected java.util.Date stichwahlWahldatum =  null;

  @javax.persistence.Transient
  protected boolean hasChangedStichwahlWahldatum = false;

  public boolean hasChangedStichwahlWahldatum(){
    return hasChangedStichwahlWahldatum;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertStichwahlWahldatum = false;
     @javax.persistence.Transient
     private transient java.util.Date wertNachLadenStichwahlWahldatum;
  
  /**
   * 
   *
   * getter for WAHLTERMIN.STICHWAHL_TERMIN
   */
  @javax.annotation.Nullable   @Override   public  java.util.Date getStichwahlWahldatum() {
              if (stichwahlWahldatum == null){
            return null;
          } else {
                          return stichwahlWahldatum;
          }
      }

  /**
   * 
   *
   * setter for WAHLTERMIN.STICHWAHL_TERMIN
   *
   * @param stichwahlWahldatum
   */
  @Override   public void setStichwahlWahldatum(@javax.annotation.Nullable  java.util.Date stichwahlWahldatum) {

       resetTkCache();
                  java.util.Date stichwahlWahldatumInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDate(stichwahlWahldatum);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.stichwahlWahldatum
      , stichwahlWahldatumInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStichwahlWahldatum |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("stichwahlWahldatum");
      }


             if (!isSeitLadenVeraendertStichwahlWahldatum) {
          isSeitLadenVeraendertStichwahlWahldatum = thisAttributChanged;
         if (isSeitLadenVeraendertStichwahlWahldatum){
           wertNachLadenStichwahlWahldatum=this.stichwahlWahldatum;
         }
       }
      

       this.stichwahlWahldatum = stichwahlWahldatumInternal;

         }

        
      @javax.persistence.Temporal(javax.persistence.TemporalType.DATE)
  @javax.persistence.Column(name = "WAHLDATUM", nullable = WahlterminConstants.WAHLDATUM_NULLABLE, precision=WahlterminConstants.WAHLDATUM_PRECISION)
    
  protected java.util.Date wahldatum =  null;

  @javax.persistence.Transient
  protected boolean hasChangedWahldatum = false;

  public boolean hasChangedWahldatum(){
    return hasChangedWahldatum;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertWahldatum = false;
     @javax.persistence.Transient
     private transient java.util.Date wertNachLadenWahldatum;
  
  /**
   * 
   *
   * getter for WAHLTERMIN.WAHLDATUM
   */
    @Override   public  java.util.Date getWahldatum() {
              if (wahldatum == null){
            return null;
          } else {
                          return wahldatum;
          }
      }

  /**
   * 
   *
   * setter for WAHLTERMIN.WAHLDATUM
   *
   * @param wahldatum
   */
  @Override   public void setWahldatum( java.util.Date wahldatum) {

       resetTkCache();
                  java.util.Date wahldatumInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDate(wahldatum);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahldatum
      , wahldatumInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedWahldatum |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("wahldatum");
      }


             if (!isSeitLadenVeraendertWahldatum) {
          isSeitLadenVeraendertWahldatum = thisAttributChanged;
         if (isSeitLadenVeraendertWahldatum){
           wertNachLadenWahldatum=this.wahldatum;
         }
       }
      

       this.wahldatum = wahldatumInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu CustomDataStorage
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "CUSTOM_DATA_STORAGE_ID", referencedColumnName="CUSTOM_DATA_STORAGE_ID"))
  protected de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage;

  /**
   * 
   */
  @Override
  public void setCustomDataStorage(@javax.annotation.Nullable  de.ivu.elect.business.customdata.entity.CustomDataStorage customDataStorage){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.customDataStorage
    , customDataStorage);

    attributeChanged |= thisAttributChanged;

    hasChangedCustomDataStorage |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("customDataStorage");
    }

    this.customDataStorage = customDataStorage;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.customdata.entity.CustomDataStorage getCustomDataStorage(){
    return this.customDataStorage;
  }

  @javax.persistence.Transient
  protected boolean hasChangedCustomDataStorage = false;

  public boolean hasChangedCustomDataStorage(){
    return hasChangedCustomDataStorage;
  }

  /**
   * Beziehung (unidirektional) zu EinsehenRolle
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "EINSEHEN_ID", referencedColumnName="ROLLE_ID"))
  protected de.ivu.elect.business.benutzerverwaltung.entity.Rolle einsehenRolle;

  /**
   * 
   */
  @Override
  public void setEinsehenRolle(@javax.annotation.Nullable  de.ivu.elect.business.benutzerverwaltung.entity.Rolle einsehenRolle){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.einsehenRolle
    , einsehenRolle);

    attributeChanged |= thisAttributChanged;

    hasChangedEinsehenRolle |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("einsehenRolle");
    }

    this.einsehenRolle = einsehenRolle;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.benutzerverwaltung.entity.Rolle getEinsehenRolle(){
    return this.einsehenRolle;
  }

  @javax.persistence.Transient
  protected boolean hasChangedEinsehenRolle = false;

  public boolean hasChangedEinsehenRolle(){
    return hasChangedEinsehenRolle;
  }

  /**
   * Beziehung (unidirektional) zu Mandant
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "MANDANT_ID", referencedColumnName="MANDANT_ID"))
  protected de.ivu.elect.business.mandant.entity.Mandant mandant;

  /**
   * 
   */
  @Override
  public void setMandant( de.ivu.elect.business.mandant.entity.Mandant mandant){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.mandant
    , mandant);

    attributeChanged |= thisAttributChanged;

    hasChangedMandant |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("mandant");
    }

    this.mandant = mandant;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.mandant.entity.Mandant getMandant(){
    return this.mandant;
  }

  @javax.persistence.Transient
  protected boolean hasChangedMandant = false;

  public boolean hasChangedMandant(){
    return hasChangedMandant;
  }

  /**
   * Beziehung (unidirektional) zu StichwahlWahlterminUrspruenglich
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHLTERMIN_URSPRUENGLICH_ID", referencedColumnName="WAHLTERMIN_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahltermin stichwahlWahlterminUrspruenglich;

  /**
   * 
   */
  @Override
  public void setStichwahlWahlterminUrspruenglich(@javax.annotation.Nullable  de.ivu.elect.business.wahl.entity.Wahltermin stichwahlWahlterminUrspruenglich){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.stichwahlWahlterminUrspruenglich
    , stichwahlWahlterminUrspruenglich);

    attributeChanged |= thisAttributChanged;

    hasChangedStichwahlWahlterminUrspruenglich |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("stichwahlWahlterminUrspruenglich");
    }

    this.stichwahlWahlterminUrspruenglich = stichwahlWahlterminUrspruenglich;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.wahl.entity.Wahltermin getStichwahlWahlterminUrspruenglich(){
    return this.stichwahlWahlterminUrspruenglich;
  }

  @javax.persistence.Transient
  protected boolean hasChangedStichwahlWahlterminUrspruenglich = false;

  public boolean hasChangedStichwahlWahlterminUrspruenglich(){
    return hasChangedStichwahlWahlterminUrspruenglich;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehung 1:N (bidirektional) zu WahlsByWahltermin
   *
   */
  @javax.persistence.OneToMany(targetEntity=de.ivu.elect.business.wahl.entity.Wahl.class, mappedBy="wahltermin", fetch=javax.persistence.FetchType.LAZY )
// elect deaktiviert, gibt Probleme beim Löschen  @org.hibernate.annotations.Cache(usage = org.hibernate.annotations.CacheConcurrencyStrategy.TRANSACTIONAL)
  protected java.util.Set<de.ivu.elect.business.wahl.entity.Wahl> wahlsByWahltermin;


  /**
   * getter muss read-only verwendet werden, da die Beziehung auf der anderen Seite nicht aktualisiert wird!
   */
  @Override
  public java.util.Set<de.ivu.elect.business.wahl.entity.Wahl> getWahlsByWahltermin(){
    if (wahlsByWahltermin == null){
      return  java.util.Collections.<de.ivu.elect.business.wahl.entity.Wahl>unmodifiableSet(java.util.Collections.<de.ivu.elect.business.wahl.entity.Wahl>emptySet());
    }

    return java.util.Collections.<de.ivu.elect.business.wahl.entity.Wahl>unmodifiableSet(this.wahlsByWahltermin);
  }

  @javax.persistence.Transient
  private boolean hasChangedWahlsByWahltermin = false;

  public boolean hasChangedWahlsByWahltermin() {
    return hasChangedWahlsByWahltermin;
  }

  /**
   * Hinzufuegen von de.ivu.elect.business.wahl.entity.Wahl
   */
  @Override
  public void addWahlByWahltermin(de.ivu.elect.business.wahl.entity.Wahl wahlByWahltermin){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (wahlByWahltermin != null){
          if (this.wahlsByWahltermin == null) {
            this.wahlsByWahltermin = new java.util.HashSet<>();
          }

          boolean isChanged = this.wahlsByWahltermin.add(wahlByWahltermin);

          if(!hasChangedWahlsByWahltermin) {
            hasChangedWahlsByWahltermin =  isChanged;
          }

          // andere Seite der Beziehung aktualisieren
          wahlByWahltermin.setWahltermin(this);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

  /**
   * Entfernen von de.ivu.elect.business.wahl.entity.Wahl
   */
  @Override
  public void removeWahlByWahltermin(de.ivu.elect.business.wahl.entity.Wahl wahlByWahltermin){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (wahlByWahltermin != null){
          if (this.wahlsByWahltermin != null) {
            boolean isChanged = this.wahlsByWahltermin.remove(wahlByWahltermin);

            if(!hasChangedWahlsByWahltermin) {
              hasChangedWahlsByWahltermin =  isChanged;
            }
          }

          // andere Seite der Beziehung aktualisieren
          wahlByWahltermin.setWahltermin(null);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

 /**
  * Entfernen von allen de.ivu.elect.business.wahl.entity.Wahl
  */
   @Override
   public void removeAllWahlByWahltermins(){
     java.util.Set<de.ivu.elect.business.wahl.entity.Wahl> toRemove = new java.util.HashSet<>(getWahlsByWahltermin());

     for (   de.ivu.elect.business.wahl.entity.Wahl entity:toRemove){
       removeWahlByWahltermin(entity);
     }
   }

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Wahltermin:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Wahltermin other){
                             other.buergerZugelassen = this.buergerZugelassen;
                                other.dokumentvorlagen = this.dokumentvorlagen;
                                other.farbe = this.farbe;
                                other.name = this.name;
                                other.nummer = this.nummer;
                                other.status = this.status;
                                other.stichwahlMoeglich = this.stichwahlMoeglich;
                                other.stichwahlWahldatum = this.stichwahlWahldatum;
                                other.wahldatum = this.wahldatum;
           
  other.setCustomDataStorage(this.getCustomDataStorage());
  other.setEinsehenRolle(this.getEinsehenRolle());
  other.setMandant(this.getMandant());
  other.setStichwahlWahlterminUrspruenglich(this.getStichwahlWahlterminUrspruenglich());


  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Wahltermin.class)){
        copyEntityAttributesUsingSetter((Wahltermin) other.castTo(Wahltermin.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Wahltermin: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Wahltermin other){
               other.setBuergerZugelassen(this.buergerZugelassen);
                  other.setDokumentvorlagen(this.dokumentvorlagen);
                  other.setFarbe(this.farbe);
                  other.setName(this.name);
                  other.setNummer(this.nummer);
                  other.setStatus(this.status);
                  other.setStichwahlMoeglich(this.stichwahlMoeglich);
                  other.setStichwahlWahldatum(this.stichwahlWahldatum);
                  other.setWahldatum(this.wahldatum);
       
    other.setCustomDataXml(this.getCustomDataXml());
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Wahltermin other){
                       if (hasChangedBuergerZugelassen) {
        other.setBuergerZugelassen(this.buergerZugelassen);
      }
                             if (hasChangedDokumentvorlagen) {
        other.setDokumentvorlagen(this.dokumentvorlagen);
      }
                             if (hasChangedFarbe) {
        other.setFarbe(this.farbe);
      }
                             if (hasChangedName) {
        other.setName(this.name);
      }
                             if (hasChangedNummer) {
        other.setNummer(this.nummer);
      }
                             if (hasChangedStatus) {
        other.setStatus(this.status);
      }
                             if (hasChangedStichwahlMoeglich) {
        other.setStichwahlMoeglich(this.stichwahlMoeglich);
      }
                             if (hasChangedStichwahlWahldatum) {
        other.setStichwahlWahldatum(this.stichwahlWahldatum);
      }
                             if (hasChangedWahldatum) {
        other.setWahldatum(this.wahldatum);
      }
             }




    /**
    * Hat die Entität überhaupt einen CustomDataStorage?
    */
    private boolean isCustomDataSupported() {
      return getCustomDataStorage()!=null;
    }

    @Override
    public de.ivu.elect.jee.entity.customdata.CustomData getCustomData() {
      if (isCustomDataSupported()) {
        de.ivu.elect.jee.entity.customdata.CustomData result = getCustomDataStorage().getCustomData();
        result.setTechnicalEntity(this); // Fachliche Entität bei jedem Zugriff setzen
        return result;
      }
      return de.ivu.elect.jee.entity.customdata.EmptyCustomData.INSTANCE;
    }


    @Override
    @SuppressWarnings("unchecked")
    public <T extends de.ivu.elect.jee.entity.customdata.CustomData> T getCustomData(Class<T> clazz) {
      if (isCustomDataSupported()) {
        return (T) getCustomData();
      }
      throw new IllegalStateException("Entität Wahltermin besitzt kein CustomDataStorage...");
    }


    @Override
    public void updateCustomData() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().updateCustomData();
      }
    }


    public void clearCustomDataCache() {
      if (isCustomDataSupported()) {
        getCustomDataStorage().clearCustomDataCache();
      }
    }

    public String getCustomDataXml(){
      if (isCustomDataSupported()) {
        return getCustomDataStorage().getCustomDataXml();
      }
      return "";
    }

    public void setCustomDataXml(String customDataXml){
      if (isCustomDataSupported()) {
        if (org.apache.commons.lang3.StringUtils.isBlank(customDataXml)) {
          if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
            throw new IllegalStateException("Entität Wahltermin hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
          }
          // ELECTMUC-2581
          System.err.println("Entität Wahltermin hat CustomDataStorage, soll aber kein CustomData aufnehmen: '"+customDataXml+"'");
        } else {
          getCustomDataStorage().setCustomDataXml(customDataXml);
        }
        clearCustomDataCache(); // WASDE-1131
      } else {
       if (org.apache.commons.lang3.StringUtils.isNotBlank(customDataXml)) {
         if (customDataXml.endsWith("EmptyCustomData/>")) {
            // Abwärtskompatibilität...alles gut, die alten, leeren CustomDataObjekte...
         } else {
           if (de.ivu.elect.business.system.control.FailOnUnkownCustomData.FAIL_ON_UNKNOWN_CUSTOM_DATA) {
             throw new IllegalStateException("Entität Wahltermin hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
           }
           // ELECT-5122
           System.err.println("Entität Wahltermin hat kein CustomDataStorage, soll aber CustomData aufnehmen: '"+customDataXml+"'");
         }
       }
      }
    }

    public boolean hasChangedCustomDataXml() {
      if (isCustomDataSupported()) {
        return getCustomDataStorage().hasChangedCustomDataXml();
      }
      return false;
    }


    @javax.persistence.Transient
    private transient WahlterminTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public WahlterminTK getWahlterminTK(){
    if (tkCache==null) {
    tkCache = new WahlterminTK(

getNummer()
, getWahldatum()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getWahlterminTK();
    }

  @Override
  public WahlterminUK getUk(){
    return getWahlterminUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Wahltermin.class;
  }

public WahlterminUK getWahlterminUK(){

   return  new WahlterminUK(

getNummer()
, getWahldatum()
,     getMandant()==null?null:getMandant().getMandantUK()


  );
}

  @javax.persistence.Transient
  private transient WahlterminProperties properties;

  public WahlterminProperties getProperties(){
    if (properties == null) {
      properties = new WahlterminProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public WahlterminProperties getWahlterminProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return WahlterminConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(WahlterminConstants.MESSAGE_KEY_BUERGER_ZUGELASSEN_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlterminConstants.MESSAGE_KEY_BUERGER_ZUGELASSEN_EINZAHL);

        buergerZugelassen =
     (de.ivu.elect.business.personenpruefung.control.wahlrecht.WahlrechtStaatsangehoerigkeit) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WahlterminConstants.MESSAGE_KEY_DOKUMENTVORLAGEN_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlterminConstants.MESSAGE_KEY_DOKUMENTVORLAGEN_EINZAHL);

        dokumentvorlagen =
     (de.ivu.elect.business.wahl.entity.WahlartDokumentvorlagen) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WahlterminConstants.MESSAGE_KEY_FARBE_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlterminConstants.MESSAGE_KEY_FARBE_EINZAHL);

        farbe =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WahlterminConstants.MESSAGE_KEY_NAME_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlterminConstants.MESSAGE_KEY_NAME_EINZAHL);

        name =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WahlterminConstants.MESSAGE_KEY_NUMMER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlterminConstants.MESSAGE_KEY_NUMMER_EINZAHL);

        nummer =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WahlterminConstants.MESSAGE_KEY_STATUS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlterminConstants.MESSAGE_KEY_STATUS_EINZAHL);

        status =
     (de.ivu.elect.business.wahl.entity.WahlterminStatus) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WahlterminConstants.MESSAGE_KEY_STICHWAHL_MOEGLICH_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlterminConstants.MESSAGE_KEY_STICHWAHL_MOEGLICH_EINZAHL);

        stichwahlMoeglich =
     vorher.getAttributTyp().getValueAsBoolean(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WahlterminConstants.MESSAGE_KEY_STICHWAHL_TERMIN_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlterminConstants.MESSAGE_KEY_STICHWAHL_TERMIN_EINZAHL);

        stichwahlWahldatum =
     vorher.getAttributTyp().getValueAsDate(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WahlterminConstants.MESSAGE_KEY_WAHLDATUM_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlterminConstants.MESSAGE_KEY_WAHLDATUM_EINZAHL);

        wahldatum =
     vorher.getAttributTyp().getValueAsDate(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertBuergerZugelassen) {
      result.put(WahlterminConstants.MESSAGE_KEY_BUERGER_ZUGELASSEN_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenBuergerZugelassen , buergerZugelassen));
    }
                            if (isSeitLadenVeraendertDokumentvorlagen) {
      result.put(WahlterminConstants.MESSAGE_KEY_DOKUMENTVORLAGEN_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenDokumentvorlagen , dokumentvorlagen));
    }
                            if (isSeitLadenVeraendertFarbe) {
      result.put(WahlterminConstants.MESSAGE_KEY_FARBE_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenFarbe , farbe));
    }
                            if (isSeitLadenVeraendertName) {
      result.put(WahlterminConstants.MESSAGE_KEY_NAME_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenName , name));
    }
                            if (isSeitLadenVeraendertNummer) {
      result.put(WahlterminConstants.MESSAGE_KEY_NUMMER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenNummer , nummer));
    }
                            if (isSeitLadenVeraendertStatus) {
      result.put(WahlterminConstants.MESSAGE_KEY_STATUS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenStatus , status));
    }
                            if (isSeitLadenVeraendertStichwahlMoeglich) {
      result.put(WahlterminConstants.MESSAGE_KEY_STICHWAHL_MOEGLICH_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.BOOLEAN
                , wertNachLadenStichwahlMoeglich , stichwahlMoeglich));
    }
                            if (isSeitLadenVeraendertStichwahlWahldatum) {
      result.put(WahlterminConstants.MESSAGE_KEY_STICHWAHL_TERMIN_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.DATE
                , wertNachLadenStichwahlWahldatum , stichwahlWahldatum));
    }
                            if (isSeitLadenVeraendertWahldatum) {
      result.put(WahlterminConstants.MESSAGE_KEY_WAHLDATUM_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.DATE
                , wertNachLadenWahldatum , wahldatum));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertBuergerZugelassen = false;
      wertNachLadenBuergerZugelassen = null;
                          isSeitLadenVeraendertDokumentvorlagen = false;
      wertNachLadenDokumentvorlagen = null;
                          isSeitLadenVeraendertFarbe = false;
      wertNachLadenFarbe = null;
                          isSeitLadenVeraendertName = false;
      wertNachLadenName = null;
                          isSeitLadenVeraendertNummer = false;
      wertNachLadenNummer = null;
                          isSeitLadenVeraendertStatus = false;
      wertNachLadenStatus = null;
                          isSeitLadenVeraendertStichwahlMoeglich = false;
      wertNachLadenStichwahlMoeglich = null;
                          isSeitLadenVeraendertStichwahlWahldatum = false;
      wertNachLadenStichwahlWahldatum = null;
                          isSeitLadenVeraendertWahldatum = false;
      wertNachLadenWahldatum = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "WAHLTERMIN";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Wahltermin";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(buergerZugelassen, this, WahlterminConstants.MESSAGE_KEY_BUERGER_ZUGELASSEN_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(dokumentvorlagen, this, WahlterminConstants.MESSAGE_KEY_DOKUMENTVORLAGEN_EINZAHL, validationResult);
                                                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(WahlterminConstants.FARBE_MAX_LENGTH ,  farbe, this, WahlterminConstants.MESSAGE_KEY_FARBE_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(WahlterminConstants.NAME_MAX_LENGTH ,  name, this, WahlterminConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(nummer, this, WahlterminConstants.MESSAGE_KEY_NUMMER_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(WahlterminConstants.NUMMER_MAX_LENGTH , 1 ,  nummer, this, WahlterminConstants.MESSAGE_KEY_NUMMER_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(status, this, WahlterminConstants.MESSAGE_KEY_STATUS_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(stichwahlMoeglich, this, WahlterminConstants.MESSAGE_KEY_STICHWAHL_MOEGLICH_EINZAHL, validationResult);
                                                                                                                                                    de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(wahldatum, this, WahlterminConstants.MESSAGE_KEY_WAHLDATUM_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        private transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
